<?php

namespace Firstdata\Gateway\Block\Adminhtml\Form\Field;

use Magento\Framework\DataObject;
use Magento\Framework\Exception\LocalizedException;
use Firstdata\Gateway\Block\Adminhtml\Form\Field\InterestColumn;



class EmiOptions extends \Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray {
	
 private $interestRenderer;
 


    public function _toHtml() {
        return '<div id="' . $this->getElement()->getId() . '">' . parent::_toHtml() . '</div>';
    }

    

   
   protected function _prepareToRender() 
   {
	   
		
        $this->addColumn('Label', ['label' => __('Label (The text to display on the frontend)'),'style' => 'width:90px']);
        $this->addColumn('minamount', ['label' => __('Installment Min. amount'),'style' => 'width:60px']);
        $this->addColumn('maxamount', ['label' => __('Installment Max. amount'),'style' => 'width:60px']);
        $this->addColumn('count', ['label' => __('Count (Total number of payments)'),'style' => 'width:60px']);
		$objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $scopeConfig = $objectManager->create('Magento\Framework\App\Config\ScopeConfigInterface');
        $country = $scopeConfig->getValue("payment/firstdata/country", \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
       	
			
				if($country == "mex")
			{
                                              
                $this->addColumn('period', ['label' => __('Deferment (Delay in months before cardholder starts to pay)'),'style' => 'width:60px']);
                
                $this->addColumn('interest',['label'=>__('Installment with Interest(Monthly payments with interest)'),'renderer'=>$this->getInterestRenderer()]);


			}
				$this->_addAfter = false;
				$this->_addButtonLabel = __('Add Installment');
    }
    
    /**
     * Prepare existing row data object
     *
     * @param DataObject $row
     * @throws LocalizedException
     */
    protected function _prepareArrayRow(DataObject $row)
    {
        $options = [];

        $interest=$row->getInterest();

        if($interest!==null){
            $options['option_' . $this->getInterestRenderer()->calcOptionHash($interest)] = 'selected="selected"';
        }

        $row->setData('option_extra_attrs', $options);
    }

     /**
     * @return InterestColumn
     * @throws LocalizedException
     */
    private function getInterestRenderer(){
        if(!$this->interestRenderer){
            $this->interestRenderer=$this->getLayout()->createBlock(
                InterestColumn::class,
                '',
                ['data' => ['is_render_to_js_template' => true]]);
        }
        return $this->interestRenderer;
    }

    
}