<?php

declare(strict_types=1);

namespace Firstdata\Gateway\Block\Adminhtml\Form\Field;

use Magento\Framework\View\Element\Html\Select;

class InterestColumn extends Select{

    /**
     * Set "name" for <select> element
     *
     * @param string $value
     * @return $this
     */
    public function setInputName($value)
    {
        return $this->setName($value);
    }

    /**
     * Set "id" for <select> element
     *
     * @param string $value
     * @return $this
     */
    public function setInputId($value)
    {
        return $this->setId($value);
    }

    /**
     * Render block HTML
     *
     * @return string
     */
    public function _toHtml()
    {
        if (!$this->getOptions()) {
            $this->setOptions($this->getSourceOptions());
        }
        return parent::_toHtml();
    }

    private function getSourceOptions()
    {
        return [
            ['label' => 'Yes', 'value' => 'true'],
            ['label' => 'No', 'value' => 'false'],
        ];
    }

}

?>